-- MySQL Administrator dump 1.4
--
-- ------------------------------------------------------
-- Server version	5.1.41


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;


--
-- Create schema pm
--

CREATE DATABASE IF NOT EXISTS pm;
USE pm;

--
-- Definition of table `pm_cubes`
--

DROP TABLE IF EXISTS `pm_cubes`;
CREATE TABLE `pm_cubes` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `nr` int(11) DEFAULT NULL,
  `game_id` int(11) unsigned DEFAULT NULL,
  `side` int(10) unsigned NOT NULL DEFAULT '1',
  `slot` int(10) unsigned DEFAULT NULL,
  `player` int(10) unsigned DEFAULT NULL,
  `x` int(10) NOT NULL DEFAULT '0',
  `y` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `FK_pm_cubes_1` (`game_id`),
  CONSTRAINT `FK_pm_cubes_1` FOREIGN KEY (`game_id`) REFERENCES `pm_games` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=171533 DEFAULT CHARSET=utf8;

--
-- Dumping data for table `pm_cubes`
--

/*!40000 ALTER TABLE `pm_cubes` DISABLE KEYS */;
INSERT INTO `pm_cubes` (`id`,`nr`,`game_id`,`side`,`slot`,`player`,`x`,`y`) VALUES 
 (171509,1,1,1,NULL,NULL,-5,5),
 (171510,2,1,1,NULL,NULL,19,8),
 (171511,3,1,1,NULL,NULL,5,-20),
 (171512,4,1,1,NULL,NULL,6,17),
 (171513,5,1,1,NULL,NULL,-3,7),
 (171514,6,1,1,NULL,NULL,19,4),
 (171515,7,1,1,NULL,NULL,-12,1),
 (171516,8,1,1,NULL,NULL,15,0),
 (171517,9,1,1,NULL,NULL,-21,16),
 (171518,10,1,1,NULL,NULL,23,-4),
 (171519,11,1,1,NULL,NULL,-16,5),
 (171520,12,1,1,NULL,NULL,2,17),
 (171521,1,2,1,NULL,NULL,19,-14),
 (171522,2,2,1,NULL,NULL,-3,2),
 (171523,3,2,1,NULL,NULL,-6,-11),
 (171524,4,2,1,NULL,NULL,-13,-5),
 (171525,5,2,1,NULL,NULL,-10,-11),
 (171526,6,2,1,NULL,NULL,1,15),
 (171527,7,2,1,NULL,NULL,1,-17),
 (171528,8,2,1,NULL,NULL,-16,-2),
 (171529,9,2,1,NULL,NULL,13,-2),
 (171530,10,2,1,NULL,NULL,-24,5),
 (171531,11,2,1,NULL,NULL,-21,0),
 (171532,12,2,1,NULL,NULL,-8,-16);
/*!40000 ALTER TABLE `pm_cubes` ENABLE KEYS */;


--
-- Definition of table `pm_games`
--

DROP TABLE IF EXISTS `pm_games`;
CREATE TABLE `pm_games` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `last_update` datetime NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=utf8;

--
-- Dumping data for table `pm_games`
--

/*!40000 ALTER TABLE `pm_games` DISABLE KEYS */;
INSERT INTO `pm_games` (`id`,`last_update`) VALUES 
 (1,'2011-01-23 17:38:35'),
 (2,'2011-01-23 17:38:16');
/*!40000 ALTER TABLE `pm_games` ENABLE KEYS */;


--
-- Definition of table `pm_grid`
--

DROP TABLE IF EXISTS `pm_grid`;
CREATE TABLE `pm_grid` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `game_id` int(11) unsigned DEFAULT NULL,
  `x` int(10) NOT NULL,
  `y` int(10) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `FK_pm_grid_1` (`game_id`),
  CONSTRAINT `FK_pm_grid_1` FOREIGN KEY (`game_id`) REFERENCES `pm_games` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=6328 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `pm_grid`
--

/*!40000 ALTER TABLE `pm_grid` DISABLE KEYS */;
INSERT INTO `pm_grid` (`id`,`game_id`,`x`,`y`) VALUES 
 (6276,1,-1,2),
 (6277,1,-1,3),
 (6278,1,0,2),
 (6279,1,0,3),
 (6280,1,1,2),
 (6281,1,1,3),
 (6282,1,-1,-2),
 (6283,1,-1,-3),
 (6284,1,0,-2),
 (6285,1,0,-3),
 (6286,1,1,-2),
 (6287,1,1,-3),
 (6288,1,0,10),
 (6289,1,0,-10),
 (6290,1,-5,5),
 (6291,1,19,8),
 (6292,1,5,-20),
 (6293,1,6,17),
 (6294,1,-3,7),
 (6295,1,19,4),
 (6296,1,-12,1),
 (6297,1,15,0),
 (6298,1,-21,16),
 (6299,1,23,-4),
 (6300,1,-16,5),
 (6301,1,2,17),
 (6302,2,-1,2),
 (6303,2,-1,3),
 (6304,2,0,2),
 (6305,2,0,3),
 (6306,2,1,2),
 (6307,2,1,3),
 (6308,2,-1,-2),
 (6309,2,-1,-3),
 (6310,2,0,-2),
 (6311,2,0,-3),
 (6312,2,1,-2),
 (6313,2,1,-3),
 (6314,2,0,10),
 (6315,2,0,-10),
 (6316,2,19,-14),
 (6317,2,-3,2),
 (6318,2,-6,-11),
 (6319,2,-13,-5),
 (6320,2,-10,-11),
 (6321,2,1,15),
 (6322,2,1,-17),
 (6323,2,-16,-2),
 (6324,2,13,-2),
 (6325,2,-24,5),
 (6326,2,-21,0),
 (6327,2,-8,-16);
/*!40000 ALTER TABLE `pm_grid` ENABLE KEYS */;


--
-- Definition of table `pm_keys`
--

DROP TABLE IF EXISTS `pm_keys`;
CREATE TABLE `pm_keys` (
  `game_id` int(11) unsigned DEFAULT NULL,
  `side` int(10) unsigned NOT NULL,
  `part` int(10) unsigned NOT NULL,
  KEY `Index_1` (`side`,`part`),
  KEY `FK_pm_keys_1` (`game_id`),
  CONSTRAINT `FK_pm_keys_1` FOREIGN KEY (`game_id`) REFERENCES `pm_games` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Dumping data for table `pm_keys`
--

/*!40000 ALTER TABLE `pm_keys` DISABLE KEYS */;
INSERT INTO `pm_keys` (`game_id`,`side`,`part`) VALUES 
 (1,1,5),
 (1,2,6),
 (1,3,2),
 (1,4,1),
 (1,5,4),
 (1,6,3),
 (2,1,6),
 (2,2,5),
 (2,3,2),
 (2,4,4),
 (2,5,1),
 (2,6,3);
/*!40000 ALTER TABLE `pm_keys` ENABLE KEYS */;


--
-- Definition of table `pm_logs`
--

DROP TABLE IF EXISTS `pm_logs`;
CREATE TABLE `pm_logs` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `game_id` int(11) unsigned DEFAULT NULL,
  `player` int(10) unsigned DEFAULT NULL,
  `command` varchar(64) NOT NULL,
  `date` datetime NOT NULL,
  `received` int(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `FK_pm_logs_1` (`game_id`),
  CONSTRAINT `FK_pm_logs_1` FOREIGN KEY (`game_id`) REFERENCES `pm_games` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=34 DEFAULT CHARSET=utf8;

--
-- Dumping data for table `pm_logs`
--

/*!40000 ALTER TABLE `pm_logs` DISABLE KEYS */;
INSERT INTO `pm_logs` (`id`,`game_id`,`player`,`command`,`date`,`received`) VALUES 
 (20,1,934,'$ opmove 5.1542 4.85795','2011-01-23 17:29:18',2),
 (21,1,934,'$ opmove 10.281 5.0127','2011-01-23 17:29:19',2),
 (22,1,934,'$ opget Cube5','2011-01-23 17:29:21',2),
 (23,1,918,'$ opmove -8.79179 -0.256117','2011-01-23 17:37:24',2),
 (24,1,918,'$ opmove -19.5002 -1.93566','2011-01-23 17:37:38',2),
 (25,1,918,'$ opmove -21.7363 -12.4176','2011-01-23 17:37:39',2),
 (26,1,918,'$ opmove -20.9136 -17.185','2011-01-23 17:37:40',2),
 (27,1,918,'$ opmove -21.3327 -18.6695','2011-01-23 17:37:41',2),
 (28,1,918,'$ opmove -21.6641 -18.4524','2011-01-23 17:37:41',2),
 (29,1,918,'$ opmove -21.3426 -17.5146','2011-01-23 17:37:42',2),
 (30,1,918,'$ opmove -21.6481 -15.6754','2011-01-23 17:37:42',2),
 (31,2,1138,'$ opmove 5.16375 -10.6951','2011-01-23 17:37:58',0),
 (32,2,1138,'$ opmove 6.69381 -16.1952','2011-01-23 17:37:59',0),
 (33,2,1138,'$ opmove 11.2575 -18.2993','2011-01-23 17:37:59',0);
/*!40000 ALTER TABLE `pm_logs` ENABLE KEYS */;


--
-- Definition of table `pm_players`
--

DROP TABLE IF EXISTS `pm_players`;
CREATE TABLE `pm_players` (
  `id` int(10) unsigned NOT NULL,
  `game_id` int(11) unsigned DEFAULT NULL,
  `last_update` datetime NOT NULL,
  `cube_taken_id` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `FK_pm_players_1` (`game_id`),
  CONSTRAINT `FK_pm_players_1` FOREIGN KEY (`game_id`) REFERENCES `pm_games` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `pm_players`
--

/*!40000 ALTER TABLE `pm_players` DISABLE KEYS */;
INSERT INTO `pm_players` (`id`,`game_id`,`last_update`,`cube_taken_id`) VALUES 
 (918,1,'2011-01-23 17:38:35',NULL),
 (934,1,'2011-01-23 17:38:31',NULL),
 (1138,2,'2011-01-23 17:38:16',NULL);
/*!40000 ALTER TABLE `pm_players` ENABLE KEYS */;


--
-- Definition of function `pm_game_get_id`
--

DROP FUNCTION IF EXISTS `pm_game_get_id`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` FUNCTION `pm_game_get_id`() RETURNS int(11)
BEGIN
  DECLARE game_id_T INT;

  SELECT game_id FROM pm_players WHERE id = pm_game_get_player_id() LIMIT 1 INTO game_id_T;

  RETURN game_id_T;
END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of function `pm_game_get_last_id`
--

DROP FUNCTION IF EXISTS `pm_game_get_last_id`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` FUNCTION `pm_game_get_last_id`() RETURNS int(11)
BEGIN
  DECLARE game_id INT;

  SELECT MAX(id) FROM pm_games LIMIT 1 INTO game_id;

  RETURN game_id;
END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of function `pm_game_get_player_id`
--

DROP FUNCTION IF EXISTS `pm_game_get_player_id`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` FUNCTION `pm_game_get_player_id`() RETURNS int(11)
BEGIN
  RETURN CONNECTION_ID();
END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of function `pm_logs_get_last_id`
--

DROP FUNCTION IF EXISTS `pm_logs_get_last_id`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` FUNCTION `pm_logs_get_last_id`() RETURNS int(11)
BEGIN
  DECLARE log_id INT;

  SET log_id = (SELECT MAX(id) FROM pm_logs);

  RETURN log_id;
END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `pm_chat`
--

DROP PROCEDURE IF EXISTS `pm_chat`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`%` PROCEDURE `pm_chat`(IN playerT INT, IN msg VARCHAR(256))
BEGIN
  CALL pm_logs_add(playerT, CONCAT('$ opchat ', msg));
END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `pm_clear`
--

DROP PROCEDURE IF EXISTS `pm_clear`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `pm_clear`()
BEGIN
  DELETE FROM pm_games WHERE last_update + INTERVAL 10 MINUTE < NOW();
END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `pm_cube_insert`
--

DROP PROCEDURE IF EXISTS `pm_cube_insert`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`%` PROCEDURE `pm_cube_insert`(IN slotT INT)
BEGIN

  CALL pm_logs_add(pm_game_get_player_id(), CONCAT('$ opget Slot', slotT));

END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `pm_cube_rotate`
--

DROP PROCEDURE IF EXISTS `pm_cube_rotate`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`%` PROCEDURE `pm_cube_rotate`(IN direction VARCHAR(8))
BEGIN

  CALL pm_logs_add(pm_game_get_player_id(), CONCAT('$ oprot ', direction));

END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `pm_cube_take`
--

DROP PROCEDURE IF EXISTS `pm_cube_take`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `pm_cube_take`(IN cube_id INT)
BEGIN

  CALL pm_logs_add(pm_game_get_player_id(), CONCAT('$ opget Cube', cube_id));

END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `pm_game_get`
--

DROP PROCEDURE IF EXISTS `pm_game_get`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `pm_game_get`()
BEGIN
  SELECT x, y FROM pm_cubes WHERE game_id = pm_game_get_id();
END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `pm_game_get_sides`
--

DROP PROCEDURE IF EXISTS `pm_game_get_sides`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `pm_game_get_sides`()
BEGIN
  SELECT part FROM pm_keys WHERE game_id = pm_game_get_id() ORDER BY side ASC;
END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `pm_game_join`
--

DROP PROCEDURE IF EXISTS `pm_game_join`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `pm_game_join`()
BEGIN
  DECLARE player_id INT DEFAULT 0;
  DECLARE player_nr INT DEFAULT 0;

  CALL pm_clear();

  IF (SELECT COUNT(id) FROM pm_players WHERE id = pm_game_get_player_id()) = 1 THEN
    DELETE FROM pm_players WHERE id = pm_game_get_player_id();
  END IF;

  IF pm_game_get_last_id() IS NULL OR (SELECT COUNT(id) FROM pm_players WHERE game_id = pm_game_get_last_id()) = 2 THEN
    CALL pm_game_make(24);
    SET player_nr = 1;
  ELSE
    SET player_nr = 2;
  END IF;

  INSERT INTO pm_players VALUES(pm_game_get_player_id(), pm_game_get_last_id(), NOW(), NULL);
  SELECT player_nr;
END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `pm_game_make`
--

DROP PROCEDURE IF EXISTS `pm_game_make`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `pm_game_make`(IN grid_size INT)
BEGIN
  DECLARE cube_x INT DEFAULT 0;
  DECLARE cube_y INT DEFAULT 0;
  DECLARE cube_nr INT DEFAULT 0;
  DECLARE key_side INT DEFAULT 0;
  DECLARE key_part INT DEFAULT 1;
  DECLARE new_game_id INT DEFAULT 1;

  # SET new_game_id = pm_game_get_last_id(),0) + 1;

  IF pm_game_get_last_id() IS NOT NULL THEN
    SET new_game_id = pm_game_get_last_id() + 1;
  END IF;

  INSERT INTO pm_games VALUES(new_game_id, NOW());

	WHILE cube_nr < 12 DO
    SET cube_nr = cube_nr + 1;
    INSERT INTO pm_cubes(nr, game_id) VALUES(cube_nr, new_game_id);
  END WHILE;

	
	INSERT INTO pm_grid(x, y) VALUES (-1, 2), (-1, 3), (0, 2), (0, 3), (1, 2), (1, 3);
	INSERT INTO pm_grid(x, y) VALUES (-1, -2), (-1, -3), (0, -2), (0, -3), (1, -2), (1, -3);

	
	INSERT INTO pm_grid(x, y) VALUES (0, 10), (0, -10);

  UPDATE pm_grid SET game_id = new_game_id WHERE game_id IS NULL OR game_id = 0;
  
	WHILE (SELECT COUNT(*) FROM pm_cubes WHERE x = 0 AND y = 0 AND game_id = new_game_id) > 0 DO
		SET cube_x = FLOOR((RAND() * 2 * grid_size) - grid_size);
		SET cube_y = FLOOR((RAND() * 2 * grid_size) - grid_size);

    
		IF (SELECT COUNT(*) FROM pm_grid WHERE x = cube_x AND y = cube_y AND game_id = new_game_id) = 0 THEN
			UPDATE pm_cubes SET x = cube_x, y = cube_y WHERE x = 0 AND y = 0 AND game_id = new_game_id ORDER BY id LIMIT 1;
      INSERT INTO pm_grid(game_id, x, y) VALUES (new_game_id, cube_x, cube_y);
		END IF;
	END WHILE;


  WHILE key_side < 6 DO
    SET key_side = key_side + 1;
    SET key_part = 1 + FLOOR(RAND() * 6);

    WHILE (SELECT COUNT(*) FROM pm_keys WHERE part = key_part AND game_id = new_game_id) > 0 DO
      SET key_part = 1 + FLOOR(RAND() * 6);
    END WHILE;

    INSERT INTO pm_keys VALUES (new_game_id, key_side, key_part);
  END WHILE;

END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `pm_game_update`
--

DROP PROCEDURE IF EXISTS `pm_game_update`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `pm_game_update`()
BEGIN
  UPDATE pm_logs SET received = 1 WHERE game_id = pm_game_get_id() AND player != pm_game_get_player_id() AND received = 0;
  SELECT command FROM pm_logs WHERE game_id = pm_game_get_id() AND player != pm_game_get_player_id() AND received = 1 ORDER BY date ASC;
  UPDATE pm_logs SET received = 2 WHERE game_id = pm_game_get_id() AND player != pm_game_get_player_id() AND received = 1;
  UPDATE pm_players SET last_update = NOW() WHERE game_id = pm_game_get_id() AND id = pm_game_get_player_id();
  UPDATE pm_games SET last_update = NOW() WHERE id = pm_game_get_id();
END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `pm_game_update_data`
--

DROP PROCEDURE IF EXISTS `pm_game_update_data`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `pm_game_update_data`(IN log_idT INT)
BEGIN
  SELECT `field`, `value` FROM pm_logs_data WHERE log_id = log_idT;

  IF (SELECT COUNT(*) FROM pm_logs WHERE log_id = log_idT AND player IS NOT NULL) = 1 THEN
    DELETE FROM pm_logs WHERE log_id = log_idT;
  END IF;
END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `pm_game_win`
--

DROP PROCEDURE IF EXISTS `pm_game_win`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`%` PROCEDURE `pm_game_win`(IN playerT INT)
BEGIN
  CALL pm_logs_add(0, CONCAT('$ system win', playerT));
END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `pm_logs_add`
--

DROP PROCEDURE IF EXISTS `pm_logs_add`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `pm_logs_add`(IN playerT INT, IN commandT VARCHAR(64))
BEGIN
  INSERT INTO pm_logs VALUES(NULL, pm_game_get_id(), playerT, commandT, NOW(), 0);
END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `pm_move`
--

DROP PROCEDURE IF EXISTS `pm_move`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`%` PROCEDURE `pm_move`(IN x_to FLOAT, IN y_to FLOAT
)
BEGIN
  CALL pm_logs_add(pm_game_get_player_id(), CONCAT('$ opmove ', x_to, ' ', y_to));
END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `pm_reset`
--

DROP PROCEDURE IF EXISTS `pm_reset`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `pm_reset`()
BEGIN
  DELETE FROM pm_cubes;
  DELETE FROM pm_games;
  DELETE FROM pm_grid;
  DELETE FROM pm_keys;
  DELETE FROM pm_logs;
  DELETE FROM pm_players;
END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;



/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
