package com.puzzledmonkey.db;

// MySQL Connector/J is a JDBC-3.0 Type 4 driver,
// which means that it is pure Java.
// Ubuntu package: libmysql-java
// Download: http://www.mysql.com/products/connector/
// Tutorial: "Using JDBC with MySQL, Getting Started"
// http://www.developer.com/java/data/article.php/3417381/Using-JDBC-with-MySQL-Getting-Started.htm
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.LinkedList;
import java.util.Queue;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author TomDalek
 */
public class MasterConnector {

    Connection con = null;
    Thread updater = null;
    Queue<String> updateQueue = new LinkedList();

    public MasterConnector(int playerID) {

        // Connecting to database
        try {
            Class.forName("com.mysql.jdbc.Driver");
//            con = DriverManager.getConnection("jdbc:mysql://remoteip/database_name", "user", "pass");
//            con = DriverManager.getConnection("jdbc:mysql://localhost:3306/pm", "root", "");
//            con = DriverManager.getConnection("jdbc:mysql://tomdalek.com:3306/tomdal01_test", "tomdal01_test", "secret");
//            con = DriverManager.getConnection("jdbc:mysql://192.168.1.102:3306/pm", "root", "secret");
            con = DriverManager.getConnection("jdbc:mysql://172.17.8.120:3306/pm", "root", "secret");
        } catch (Exception e) {
            e.printStackTrace();
            System.out.println("Exception: " + e.getMessage());
        }

        updater = new Thread(new Updater(con, updateQueue, playerID));
        updater.start();
    }

    public void stop() {
        updater.stop();
        try {
            if (con != null) {
                con.close();
            }
        } catch (SQLException e) {
        }
    }

    public Queue<String> getUpdateQueue() {
        Queue<String> returnQueue = new LinkedList<String>();
        while (!updateQueue.isEmpty()) {
            returnQueue.add(updateQueue.poll());
        }
        return returnQueue;
    }

    public int[][] gameGet() {
        int[][] cubesArray = new int[12][2];
        try {
            Statement st = con.createStatement();
            ResultSet rs = st.executeQuery("call pm_game_get()");
            int i = 0;
            while (rs.next()) {
                System.out.print("x: " + rs.getInt(1));
                System.out.println("y: " + rs.getInt(2));

                cubesArray[i][0] = rs.getInt(1);
                cubesArray[i][1] = rs.getInt(2);
                i++;
            }
        } catch (SQLException ex) {
            Logger.getLogger(MasterConnector.class.getName()).log(Level.SEVERE, null, ex);
        }
        return cubesArray;
    }

    public void gameMake(int gridSize) {
        try {
            Statement st = con.createStatement();
            ResultSet rs = st.executeQuery("call pm_game_make(" + gridSize + ")");
        } catch (SQLException ex) {
            Logger.getLogger(MasterConnector.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public int gameJoin() {
        int playerID = 0;

        try {
            Statement st = con.createStatement();
            ResultSet rs = st.executeQuery("call pm_game_join()");
            int i = 0;
            while (rs.next()) {
                playerID = rs.getInt(1);
            }
        } catch (SQLException ex) {
            Logger.getLogger(MasterConnector.class.getName()).log(Level.SEVERE, null, ex);
        }

         return playerID;
    }

    public int[] gameGetSides() {
        int[] sidesVector = new int[6];
        try {
            Statement st = con.createStatement();
            ResultSet rs = st.executeQuery("call pm_game_get_sides()");
            int i = 0;
            while (rs.next()) {
                sidesVector[i] = rs.getInt(1);
                i++;
            }
        } catch (SQLException ex) {
            Logger.getLogger(MasterConnector.class.getName()).log(Level.SEVERE, null, ex);
        }
        return sidesVector;
    }

    public void move(int playerID, float x, float y) {
        try {
            Statement st = con.createStatement();
            ResultSet rs = st.executeQuery("call pm_move(" + x + "," + y + ")");

            System.out.println("call pm_move(" + x + "," + y + ")");
        } catch (SQLException ex) {
            Logger.getLogger(MasterConnector.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void cubeRotate(int playerID, String direction) {
        try {
            Statement st = con.createStatement();
            ResultSet rs = st.executeQuery("call pm_cube_rotate('" + direction + "')");
        } catch (SQLException ex) {
            Logger.getLogger(MasterConnector.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void cubeTake(int playerID, int cubeID) {
        try {
            Statement st = con.createStatement();
            ResultSet rs = st.executeQuery("call pm_cube_take(" + cubeID + ")");
        } catch (SQLException ex) {
            Logger.getLogger(MasterConnector.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void cubeInsert(int playerID, int cubeID) {
        try {
            Statement st = con.createStatement();
            ResultSet rs = st.executeQuery("call pm_cube_insert(" + cubeID + ")");
        } catch (SQLException ex) {
            Logger.getLogger(MasterConnector.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void chat(int playerID, String message) {
        try {
            Statement st = con.createStatement();
            ResultSet rs = st.executeQuery("call pm_chat(" + message + "')");
        } catch (SQLException ex) {
            Logger.getLogger(MasterConnector.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void gameWin(int playerID) {
        try {
            Statement st = con.createStatement();
            ResultSet rs = st.executeQuery("call pm_mage_win()");
        } catch (SQLException ex) {
            Logger.getLogger(MasterConnector.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}
