/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.puzzledmonkey.jme;

import com.jme3.asset.AssetManager;
import com.jme3.material.Material;
import com.jme3.math.ColorRGBA;
import com.jme3.math.Vector3f;
import com.jme3.scene.Geometry;
import com.jme3.scene.Node;
import com.jme3.scene.debug.Arrow;

/**
 *
 * @author maly
 */
class AxisRods extends Node {
    private float size;
    private float lineWidth = 3;
    private AssetManager assetManager;
    

    AxisRods(AssetManager assetManager, String name, float size) {
        super(name);
        this.size = size;
        this.assetManager = assetManager;
        
        initRods();
    }

    private void initRods() {
        Arrow arrowX = new Arrow(Vector3f.UNIT_X.mult(size));
        Arrow arrowY = new Arrow(Vector3f.UNIT_Y.mult(size));
        Arrow arrowZ = new Arrow(Vector3f.UNIT_Z.mult(size));
        arrowX.setLineWidth(lineWidth);
        arrowY.setLineWidth(lineWidth);
        arrowZ.setLineWidth(lineWidth);

        Geometry geomX = new Geometry("ArrowX", arrowX);
        Geometry geomY = new Geometry("ArrowY", arrowY);
        Geometry geomZ = new Geometry("ArrowZ", arrowZ);
        Material matX = new Material(assetManager, "Common/MatDefs/Misc/SolidColor.j3md");
        Material matY = new Material(assetManager, "Common/MatDefs/Misc/SolidColor.j3md");
        Material matZ = new Material(assetManager, "Common/MatDefs/Misc/SolidColor.j3md");
        matX.setColor("m_Color", ColorRGBA.Red);
        matY.setColor("m_Color", ColorRGBA.Green);
        matZ.setColor("m_Color", ColorRGBA.Blue);
        geomX.setMaterial(matX);
        geomY.setMaterial(matY);
        geomZ.setMaterial(matZ);

        this.attachChild(geomX);
        this.attachChild(geomY);
        this.attachChild(geomZ);
    }
    
}
