package com.puzzledmonkey.db;

import java.util.logging.Level;
import java.util.logging.Logger;
import org.junit.BeforeClass;
import org.junit.Test;

/**
 * @author TomDalek
 */
public class MasterConnectorTest {

    static MasterConnector mc1;
    static MasterConnector mc2;
    private int gridSize = 24;

    @BeforeClass
    public static void setUpBeforeClass() throws Exception {
        mc1 = new MasterConnector(1);
        mc2 = new MasterConnector(2);
    }

    @Test
    public void gameMakeJoinTest() {
        try {

//            mc1.gameMake(gridSize);
            mc1.gameMake(gridSize);
            mc2.gameJoin();

            System.out.println("Start sleepnig...");
            Thread.sleep(500);
            System.out.println("End sleepnig...");
            for (String command : mc1.getUpdateQueue()) {
                System.out.println("mc1 got command: " + command);
            }
            for (String command : mc2.getUpdateQueue()) {
                System.out.println("mc2 got command: " + command);
            }
        } catch (InterruptedException ex) {
            Logger.getLogger(MasterConnectorTest.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    @Test
    public void cubeTakeTest(){
        System.out.println("===========");
        try {
            //            mc.cubeTake(playerID, cubeID);
            mc1.cubeTake(1, 1);
            mc2.cubeTake(2, 12);
            //            mc.cubeTake(playerID, cubeID);
            System.out.println("Start sleepnig...");
            Thread.sleep(500);
            System.out.println("End sleepnig...");
            for (String command : mc1.getUpdateQueue()) {
                System.out.println("mc1 got command: " + command);
            }
            for (String command : mc2.getUpdateQueue()) {
                System.out.println("mc2 got command: " + command);
            }
        } catch (InterruptedException ex) {
            Logger.getLogger(MasterConnectorTest.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    @Test
    public void stopTest() {
        mc1.stop();
        mc2.stop();
    }
}
